/*
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 * 
 * $Id: sockets.h 247 2005-05-17 15:11:27Z drstein $
 *
 */

#ifndef SOCKETS_H
#define SOCKETS_H

#ifdef _WIN32
typedef SOCKET				deno_socket_t;
#define deno_sockread(fd, buf, len)	recv(fd, buf, len, 0)
#define deno_sockwrite(fd, buf, len)	 send(fd, buf, len, 0)
#define deno_sockclose(fd)		closesocket(fd)
#define deno_sockgeterr()		WSAGetLastError()
#define deno_sockseterr(err)		WSASetLastError(err)
/* deno_sockstrerror in sockutil.c */
/* deno_socksetnonb in sockutil.c */
#define deno_sockerrnonb(err)		(err == WSAEINPROGRESS || err == WSAEWOULDBLOCK)
#define SOCKERR_EBADF			WSAENOTSOCK
#define SOCKERR_EINTR			WSAEINTR
#define SOCKERR_EINVAL			WSAEINVAL
#define SOCKERR_EINPROGRESS		WSAEINPROGRESS
#else
typedef	int				deno_socket_t;
#define deno_sockread(fd, buf, len)	read(fd, buf, len)
#define deno_sockwrite(fd, buf, len) 	write(fd, buf, len)
#define deno_sockclose(fd)		close(fd)
#define deno_sockgeterr()		errno
#define deno_sockseterr(err)		errno = err
#define deno_sockstrerror(err)		strerror(err)
#define deno_socksetnonb(fd)		fcntl(fd, F_SETFL, O_NONBLOCK)
#define deno_sockerrnonb(err)		(err == EINPROGRESS)
#define SOCKERR_EBADF			EBADF
#define SOCKERR_EINTR			EINTR
#define SOCKERR_EINVAL			EINVAL
#define SOCKERR_EINPROGRESS		EINPROGRESS
#endif

#endif

