/*
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 * 
 * $Id: musircd.h 427 2005-07-23 08:40:36Z trystan $
 *
 */

#define IRC_UMODE_a 0x00000001  /* Admin status */
#define IRC_UMODE_b 0x00000080  /* See bot and drone flooding notices */
#define IRC_UMODE_c 0x00000100  /* Client connection/quit notices */
#define IRC_UMODE_d 0x00000200  /* See debugging notices */
#define IRC_UMODE_f 0x00000400  /* See I: line full notices */
#define IRC_UMODE_g 0x00000800  /* Server Side Ignore */
#define IRC_UMODE_i 0x00000004  /* Not shown in NAMES or WHO unless you share a channel */
#define IRC_UMODE_k 0x00001000  /* See server generated KILL messages */
#define IRC_UMODE_l 0x00002000  /* See LOCOPS messages */
#define IRC_UMODE_n 0x00004000  /* See client nick changes */
#define IRC_UMODE_o 0x00000008  /* Operator status */
#define IRC_UMODE_r 0x00000010  /* See rejected client notices */
#define IRC_UMODE_s 0x00008000  /* See general server notices */
#define IRC_UMODE_u 0x00010000  /* See unauthorized client notices */
#define IRC_UMODE_w 0x00000020  /* See server generated WALLOPS */
#define IRC_UMODE_I 0x00020000
#define IRC_UMODE_y 0x00040000  /* See LINKS, STATS (if configured), TRACE notices */
#define IRC_UMODE_D 0x00080000
#define IRC_UMODE_S 0x00100000
#define IRC_UMODE_A 0x00100000


#define IRCD_CMODE_i 0x00000001     /* Invite only */
#define IRCD_CMODE_m 0x00000002     /* Users without +v/h/o cannot send text to the channel */
#define IRCD_CMODE_n 0x00000004     /* Users must be in the channel to send text to it */
#define IRCD_CMODE_p 0x00000008     /* Private is obsolete, this now restricts KNOCK */
#define IRCD_CMODE_s 0x00000010     /* The channel does not show up on NAMES or LIST */
#define IRCD_CMODE_t 0x00000020     /* Only chanops can change the topic */
#define IRCD_CMODE_k 0x00000040     /* Key/password for the channel. */
#define IRCD_CMODE_l 0x00000080     /* Limit the number of users in a channel */
#define IRCD_CMODE_C 0x00000100
#define IRCD_CMODE_c 0x00000200

void musircd_cmd_nick(char *nick, char *name, const char *modes);
void musircd_cmd_mode(char *source, char *dest, char *buf);
void musircd_cmd_bot_nick(char *nick, char *user, char *host, char *real, char *modes);
void musircd_cmd_notice(char *source, char *dest, char *buf);
void musircd_cmd_privmsg(char *source, char *dest, char *buf);
void musircd_cmd_serv_notice(char *source, char *dest, char *msg);
void musircd_cmd_serv_privmsg(char *source, char *dest, char *msg);
void musircd_cmd_351(char *source);
void musircd_cmd_quit(char *source, char *buf);
void musircd_cmd_pong(char *servname, char *who);
void musircd_cmd_join(char *user, char *channel, time_t chantime);
void musircd_cmd_part(char *nick, char *chan, char *buf);
void musircd_cmd_global(char *source, char *buf);
void musircd_cmd_squit(char *servname, char *message);
void musircd_cmd_connect(void);
void musircd_cmd_eob(void);
void musircd_cmd_ctcp(char *source, char *dest, char *buf);
void musircd_cmd_version(char *server);
void musircd_cmd_stats(char *sender, const char *letter, char *server);
void musircd_cmd_motd(char *sender, char *server);
void musircd_cmd_ping(char *server);
void musircd_cmd_pass(char *pass);
void musircd_cmd_server(char *servname, int hop, char *descript);
void musircd_cmd_capab(void);
void musircd_cmd_svinfo(void);

int denora_event_sqline(char *source, int ac, char **av);
int denora_event_436(char *source, int ac, char **av);
int denora_event_away(char *source, int ac, char **av);
int denora_event_ping(char *source, int ac, char **av);
int denora_event_motd(char *source, int ac, char **av);
int denora_event_join(char *source, int ac, char **av);
int denora_event_kick(char *source, int ac, char **av);
int denora_event_kill(char *source, int ac, char **av);
int denora_event_mode(char *source, int ac, char **av);
int denora_event_quit(char *source, int ac, char **av);
int denora_event_squit(char *source, int ac, char **av);
int denora_event_topic(char *source, int ac, char **av);
int denora_event_whois(char *source, int ac, char **av);
int denora_event_part(char *source, int ac, char **av);
int denora_event_server(char *source, int ac, char **av);
int denora_event_nick(char *source, int ac, char **av);
int denora_event_privmsg(char *source, int ac, char **av);
int denora_event_capab(char *source, int ac, char **av);
int denora_event_sjoin(char *source, int ac, char **av);
int denora_event_svinfo(char *source, int ac, char **av);
int denora_event_svsinfo(char *source, int ac, char **av);
int denora_event_eob(char *source, int ac, char **av);
int denora_event_pass(char *source, int ac, char **av);
int denora_event_error(char *source, int ac, char **av);
int denora_event_notice(char *source, int ac, char **av);
int denora_event_globops(char *source, int ac, char **av);
int denora_event_burst(char *source, int ac, char **av);
int denora_event_pong(char *source, int ac, char **av);
int denora_event_swhois(char *source, int ac, char **av);
int denora_event_sethost(char *source, int ac, char **av);
int denora_event_tburst(char *source, int ac, char **av);

int DenoraInit(int argc, char **argv);
void moduleAddIRCDMsgs(void);
void moduleAddIRCDCmds(void);
void DenoraFini(void);
