/* ShadowIRCD functions
 *
 * (C) 2003-2005 Anope Team
 * Contact us at info@anope.org
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Epona by Lara.
 * Based on the original code of Services by Andy Church. 
 * 
 * $Id: shadowircd.h 427 2005-07-23 08:40:36Z trystan $
 *
 */

/* The protocol revision. */
#define PROTOCOL_REVISION 3402

#define IRC_UMODE_a 0x00000001
#define IRC_UMODE_C 0x00000002
#define IRC_UMODE_i 0x00000004
#define IRC_UMODE_o 0x00000008
#define IRC_UMODE_z 0x00000010
#define IRC_UMODE_w 0x00000020
#define IRC_UMODE_s 0x00000040
#define IRC_UMODE_c 0x00000080
#define IRC_UMODE_r 0x00000100
#define IRC_UMODE_k 0x00000200
#define IRC_UMODE_f 0x00000400
#define IRC_UMODE_y 0x00000800
#define IRC_UMODE_d 0x00001000
#define IRC_UMODE_n 0x00002000
#define IRC_UMODE_x 0x00004000
#define IRC_UMODE_u 0x00008000
#define IRC_UMODE_b 0x00010000
#define IRC_UMODE_l 0x00020000
#define IRC_UMODE_g 0x00040000
#define IRC_UMODE_v 0x00080000
#define IRC_UMODE_A 0x00100000
#define IRC_UMODE_E 0x00200000
#define IRC_UMODE_G 0x00400000
#define IRC_UMODE_R 0x00800000
#define IRC_UMODE_e 0x01000000
#define IRC_UMODE_O 0x02000000
#define IRC_UMODE_H 0x04000000

#define IRCD_CMODE_i 0x00000001
#define IRCD_CMODE_m 0x00000002
#define IRCD_CMODE_n 0x00000004
#define IRCD_CMODE_p 0x00000008
#define IRCD_CMODE_s 0x00000010
#define IRCD_CMODE_t 0x00000020
#define IRCD_CMODE_k 0x00000040
#define IRCD_CMODE_l 0x00000080
#define IRCD_CMODE_K 0x00000100
#define IRCD_CMODE_A 0x00000200
#define IRCD_CMODE_r 0x00000400
#define IRCD_CMODE_z 0x00000800
#define IRCD_CMODE_S 0x00001000
#define IRCD_CMODE_c 0x00002000
#define IRCD_CMODE_E 0x00004000
#define IRCD_CMODE_F 0x00008000
#define IRCD_CMODE_G 0x00010000
#define IRCD_CMODE_L 0x00020000
#define IRCD_CMODE_N 0x00040000
#define IRCD_CMODE_O 0x00080000
#define IRCD_CMODE_P 0x00100000
#define IRCD_CMODE_R 0x00200000
#define IRCD_CMODE_T 0x00400000
#define IRCD_CMODE_V 0x00800000

void shadowircd_cmd_nick(char *nick, char *name, const char *modes);
void shadowircd_cmd_mode(char *source, char *dest, char *buf);
void shadowircd_cmd_bot_nick(char *nick, char *user, char *host, char *real, char *modes);
void shadowircd_cmd_notice(char *source, char *dest, char *buf);
void shadowircd_cmd_privmsg(char *source, char *dest, char *buf);
void shadowircd_cmd_serv_notice(char *source, char *dest, char *msg);
void shadowircd_cmd_serv_privmsg(char *source, char *dest, char *msg);
void shadowircd_cmd_bot_chan_mode(char *nick, char *chan);
void shadowircd_cmd_351(char *source);
void shadowircd_cmd_quit(char *source, char *buf);
void shadowircd_cmd_pong(char *servname, char *who);
void shadowircd_cmd_join(char *user, char *channel, time_t chantime);
void shadowircd_cmd_part(char *nick, char *chan, char *buf);
void shadowircd_cmd_global(char *source, char *buf);
void shadowircd_cmd_squit(char *servname, char *message);
void shadowircd_cmd_connect(void);
void shadowircd_cmd_eob(void);
void shadowircd_cmd_ctcp(char *source, char *dest, char *buf);
void shadowircd_cmd_version(char *server);
void shadowircd_cmd_stats(char *sender, const char *letter, char *server);
void shadowircd_cmd_motd(char *sender, char *server);
void shadowircd_cmd_ping(char *server);
void shadowircd_cmd_pass(char *pass);
void shadowircd_cmd_server(char *servname, int hop, char *descript);
void shadowircd_cmd_372(char *source, char *msg);
void shadowircd_cmd_capab(void);
void shadowircd_cmd_svinfo(void);
void shadowircd_cmd_svsinfo(void);

int denora_event_436(char *source, int ac, char **av);
int denora_event_away(char *source, int ac, char **av);
int denora_event_ping(char *source, int ac, char **av);
int denora_event_motd(char *source, int ac, char **av);
int denora_event_join(char *source, int ac, char **av);
int denora_event_kick(char *source, int ac, char **av);
int denora_event_kill(char *source, int ac, char **av);
int denora_event_mode(char *source, int ac, char **av);
int denora_event_quit(char *source, int ac, char **av);
int denora_event_squit(char *source, int ac, char **av);
int denora_event_topic(char *source, int ac, char **av);
int denora_event_whois(char *source, int ac, char **av);
int denora_event_part(char *source, int ac, char **av);
int denora_event_server(char *source, int ac, char **av);
int denora_event_nick(char *source, int ac, char **av);
int denora_event_gnotice(char *source, int ac, char **av);
int denora_event_privmsg(char *source, int ac, char **av);
int denora_event_capab(char *source, int ac, char **av);
int denora_event_sjoin(char *source, int ac, char **av);
int denora_event_svinfo(char *source, int ac, char **av);
int denora_event_chghost(char *source, int ac, char **av);
int denora_event_sethost(char *source, int ac, char **av);
int denora_event_chgident(char *source, int ac, char **av);
int denora_event_setident(char *source, int ac, char **av);
int denora_event_chgname(char *source, int ac, char **av);
int denora_event_setname(char *source, int ac, char **av);
int denora_event_svsinfo(char *source, int ac, char **av);
int denora_event_snick(char *source, int ac, char **av);
int denora_event_vhost(char *source, int ac, char **av);
int denora_event_tkl(char *source, int ac, char **av);
int denora_event_eos(char *source, int ac, char **av);
int denora_event_pass(char *source, int ac, char **av);
int denora_event_error(char *source, int ac, char **av);
int denora_event_netctrl(char *source, int ac, char **av);
int denora_event_notice(char *source, int ac, char **av);
int denora_event_snotice(char *source, int ac, char **av);
int denora_event_smo(char *source, int ac, char **av);
int denora_event_myid(char *source, int ac, char **av);
int denora_event_umode2(char *source, int ac, char **av);
int denora_event_globops(char *source, int ac, char **av);
int denora_event_swhois(char *source, int ac, char **av);
int denora_event_burst(char *source, int ac, char **av);
int denora_event_sdesc(char *source, int ac, char **av);
int denora_event_svsmode(char *source, int ac, char **av);
int denora_event_tmode(char *source, int ac, char **av);
int denora_event_bmask(char *source, int ac, char **av);
int denora_event_sid(char *source, int ac, char **av);
int denora_event_pong(char *source, int ac, char **av);
int denora_event_tburst(char *source, int ac, char **av);

int DenoraInit(int argc, char **argv);
void moduleAddIRCDMsgs(void);
void moduleAddIRCDCmds(void);
void DenoraFini(void);
