
/*
 *
 * (C) 2004-2005 Denora Team
 * Contact us at info@nomadirc.net
 *
 * Please read COPYING and README for furhter details.
 *
 * Based on the original code of Anope by Anope Team.
 * Based on the original code of Thales by Lucas.
 * 
 * $Id: sort.c 384 2005-07-03 20:23:33Z trystan $
 *
 */

#include "denora.h"

int find_in_sortedlist(TLD * sortedlist, char *string);
int find_in_sc_sortedlist(StatsChannel * sortedlist, char *string);
int find_in_ctcp_sortedlist(CTCPVerStats * sortedlist, char *string);

/*************************************************************************/

TLD *tld_sort()
{
    TLD *list, *temp;
    TLD *sortedlist = NULL;
    TLD *firstsortedlist = NULL;
    TLD *dummy;
    int i;

    list = first_tld();

    /* list is empty */
    if (!list) {
        return NULL;
    }

    /* create an empty dummy TLD */
    dummy = scalloc(sizeof(TLD), 1);
    strscpy(dummy->countrycode, "", 3);
    dummy->overall = 0;
    dummy->count = 0;

    for (i = 1; i <= 10; i++) {
        list = first_tld();
        temp = dummy;
        /* search the list for the highest value */
        while (list) {
            if (sortedlist) {
                if ((list->count > temp->count)
                    && (list->count < sortedlist->count)) {
                    temp = list;
                } else if ((list->count == sortedlist->count)
                           && !find_in_sortedlist(firstsortedlist,
                                                  list->country)) {
                    temp = list;
                }
            } else {
                if (list->count > temp->count) {
                    temp = list;
                }
            }
            /* jump to next entry in list */
            list = next_tld();
        }

        /* at the end of this loop temp should point to the highest value in list, that is smaller 
           than all other values already found */

        if (temp->country) {
            if (!sortedlist) {
                /* make first entry in sorted list */
                sortedlist = temp;
                sortedlist->prevsort = NULL;
                sortedlist->nextsort = NULL;
                /* we will return this */
                firstsortedlist = sortedlist;
            } else {
                /* If we got the dummy, let's get out of here */
                if (!stricmp(temp->countrycode, ""))
                    break;
                /* make a new entry in sorted list */
                sortedlist->nextsort = temp;
                temp->prevsort = sortedlist;
                temp->nextsort = NULL;
                sortedlist = temp;
            }
        }
    }

    /* free dummy */
    denora_free(dummy->country);
    denora_free(dummy);

    return firstsortedlist;
}

/*************************************************************************/

StatsChannel *kick_sort()
{
    StatsChannel *list, *temp;
    StatsChannel *sortedlist = NULL;
    StatsChannel *firstsortedlist = NULL;
    StatsChannel *dummy;
    int i;

    list = first_statschan();

    /* list is empty */
    if (!list) {
        return NULL;
    }

    /* create an empty dummy StatsChannel */
    dummy = scalloc(sizeof(StatsChannel), 1);
    strscpy(dummy->name, "", 3);
    dummy->kickcount = 0;

    for (i = 1; i <= 10; i++) {
        list = first_statschan();
        temp = dummy;
        /* search the list for the highest value */
        while (list) {
            if (SP_HTML) {
                if (has_cmode(list->name, CMODE_s)
                    || has_cmode(list->name, CMODE_p)) {
                    list = next_statschan();
                    continue;
                }
            }
            if (sortedlist) {
                if ((list->kickcount > temp->kickcount)
                    && (list->kickcount < sortedlist->kickcount)) {
                    temp = list;
                } else if ((list->kickcount == sortedlist->kickcount)
                           && !find_in_sc_sortedlist(firstsortedlist,
                                                     list->name)) {
                    temp = list;
                }
            } else {
                if (list->kickcount > temp->kickcount) {
                    temp = list;
                }
            }
            /* jump to next entry in list */
            list = next_statschan();
        }

        /* at the end of this loop temp should point to the highest value in list, that is smaller 
           than all other values already found */

        if (temp->name) {
            if (!sortedlist) {
                /* make first entry in sorted list */
                sortedlist = temp;
                sortedlist->prevsort = NULL;
                sortedlist->nextsort = NULL;
                /* we will return this */
                firstsortedlist = sortedlist;
            } else {
                /* If we got the dummy, let's get out of here */
                if (!stricmp(temp->name, ""))
                    break;
                /* make a new entry in sorted list */
                sortedlist->nextsort = temp;
                temp->prevsort = sortedlist;
                temp->nextsort = NULL;
                sortedlist = temp;
            }
        }
    }
    
     denora_free(dummy);

    return firstsortedlist;
}

/*************************************************************************/

StatsChannel *topic_sort()
{
    StatsChannel *list, *temp;
    StatsChannel *sortedlist = NULL;
    StatsChannel *firstsortedlist = NULL;
    StatsChannel *dummy;
    int i;

    list = first_statschan();

    /* list is empty */
    if (!list) {
        return NULL;
    }

    /* create an empty dummy StatsChannel */
    dummy = scalloc(sizeof(StatsChannel), 1);
    strscpy(dummy->name, "", 3);
    dummy->topic_count = 0;

    for (i = 1; i <= 10; i++) {
        list = first_statschan();
        temp = dummy;
        /* search the list for the highest value */
        while (list) {
            if (SP_HTML) {
                if (has_cmode(list->name, CMODE_s)
                    || has_cmode(list->name, CMODE_p)) {
                    list = next_statschan();
                    continue;
                }
            }
            if (sortedlist) {
                if ((list->topic_count > temp->topic_count)
                    && (list->topic_count < sortedlist->topic_count)) {
                    temp = list;
                } else if ((list->topic_count == sortedlist->topic_count)
                           && !find_in_sc_sortedlist(firstsortedlist,
                                                     list->name)) {
                    temp = list;
                }
            } else {
                if (list->topic_count > temp->topic_count) {
                    temp = list;
                }
            }
            /* jump to next entry in list */
            list = next_statschan();
        }

        /* at the end of this loop temp should point to the highest value in list, that is smaller 
           than all other values already found */

        if (temp->name) {
            if (!sortedlist) {
                /* make first entry in sorted list */
                sortedlist = temp;
                sortedlist->prevsort = NULL;
                sortedlist->nextsort = NULL;
                /* we will return this */
                firstsortedlist = sortedlist;
            } else {
                /* If we got the dummy, let's get out of here */
                if (!stricmp(temp->name, ""))
                    break;
                /* make a new entry in sorted list */
                sortedlist->nextsort = temp;
                temp->prevsort = sortedlist;
                temp->nextsort = NULL;
                sortedlist = temp;
            }
        }
    }

    denora_free(dummy);

    return firstsortedlist;
}

/*************************************************************************/

StatsChannel *totaljoin_sort()
{
    StatsChannel *list, *temp;
    StatsChannel *sortedlist = NULL;
    StatsChannel *firstsortedlist = NULL;
    StatsChannel *dummy;
    int i;

    list = first_statschan();

    /* list is empty */
    if (!list) {
        return NULL;
    }

    /* create an empty dummy TLD */
    dummy = scalloc(sizeof(StatsChannel), 1);
    strscpy(dummy->name, "", 3);
    dummy->joincounter = 0;

    for (i = 1; i <= 10; i++) {
        list = first_statschan();
        temp = dummy;
        /* search the list for the highest value */
        while (list) {
            if (SP_HTML) {
                if (has_cmode(list->name, CMODE_s)
                    || has_cmode(list->name, CMODE_p)) {
                    list = next_statschan();
                    continue;
                }
            }
            if (sortedlist) {
                if ((list->joincounter > temp->joincounter)
                    && (list->joincounter < sortedlist->joincounter)) {
                    temp = list;
                } else if ((list->joincounter == sortedlist->joincounter)
                           && !find_in_sc_sortedlist(firstsortedlist,
                                                     list->name)) {
                    temp = list;
                }
            } else {
                if (list->joincounter > temp->joincounter) {
                    temp = list;
                }
            }
            /* jump to next entry in list */
            list = next_statschan();
        }

        /* at the end of this loop temp should point to the highest value in list, that is smaller 
           than all other values already found */

        if (temp->name) {
            if (!sortedlist) {
                /* make first entry in sorted list */
                sortedlist = temp;
                sortedlist->prevsort = NULL;
                sortedlist->nextsort = NULL;
                /* we will return this */
                firstsortedlist = sortedlist;
            } else {
                /* If we got the dummy, let's get out of here */
                if (!stricmp(temp->name, ""))
                    break;
                /* make a new entry in sorted list */
                sortedlist->nextsort = temp;
                temp->prevsort = sortedlist;
                temp->nextsort = NULL;
                sortedlist = temp;
            }
        }
    }

    denora_free(dummy);

    return firstsortedlist;
}

/*************************************************************************/

StatsChannel *top10_sort()
{
    StatsChannel *list, *temp;
    StatsChannel *sortedlist = NULL;
    StatsChannel *firstsortedlist = NULL;
    StatsChannel *dummy;
    int i;

    list = first_statschan();

    /* list is empty */
    if (!list) {
        return NULL;
    }

    /* create an empty dummy TLD */
    dummy = scalloc(sizeof(StatsChannel), 1);
    strscpy(dummy->name, "", 3);
    dummy->usercount = 0;

    for (i = 1; i <= 10; i++) {
        list = first_statschan();
        temp = dummy;
        /* search the list for the highest value */
        while (list) {
            if (SP_HTML) {
                if (has_cmode(list->name, CMODE_s)
                    || has_cmode(list->name, CMODE_p)) {
                    list = next_statschan();
                    continue;
                }
            }
            if (sortedlist) {
                if ((list->usercount > temp->usercount)
                    && (list->usercount < sortedlist->usercount)) {
                    temp = list;
                } else if ((list->usercount == sortedlist->usercount)
                           && !find_in_sc_sortedlist(firstsortedlist,
                                                     list->name)) {
                    temp = list;
                }
            } else {
                if (list->usercount > temp->usercount) {
                    temp = list;
                }
            }
            /* jump to next entry in list */
            list = next_statschan();
        }

        /* at the end of this loop temp should point to the highest value in list, that is smaller 
           than all other values already found */

        if (temp->name) {
            if (!sortedlist) {
                /* make first entry in sorted list */
                sortedlist = temp;
                sortedlist->prevsort = NULL;
                sortedlist->nextsort = NULL;
                /* we will return this */
                firstsortedlist = sortedlist;
            } else {
                /* If we got the dummy, let's get out of here */
                if (!stricmp(temp->name, ""))
                    break;
                /* make a new entry in sorted list */
                sortedlist->nextsort = temp;
                temp->prevsort = sortedlist;
                temp->nextsort = NULL;
                sortedlist = temp;
            }
        }
    }

    denora_free(dummy);

    return firstsortedlist;
}

/*************************************************************************/

CTCPVerStats *ctcp_sort()
{
    CTCPVerStats *list, *temp;
    CTCPVerStats *sortedlist = NULL;
    CTCPVerStats *firstsortedlist = NULL;
    CTCPVerStats *dummy;
    int i;

    list = first_ctcp();

    /* list is empty */
    if (!list) {
        return NULL;
    }

    /* create an empty dummy TLD */
    dummy = scalloc(sizeof(CTCPVerStats), 1);
    dummy->version = sstrdup("");
    dummy->overall = 0;

    for (i = 1; i <= 10; i++) {
        list = first_ctcp();
        temp = dummy;
        /* search the list for the highest value */
        while (list) {
            if (sortedlist) {
                if ((list->overall > temp->overall)
                    && (list->overall < sortedlist->overall)) {
                    temp = list;
                } else if ((list->overall == sortedlist->overall)
                           && !find_in_ctcp_sortedlist(firstsortedlist,
                                                       list->version)) {
                    temp = list;
                }
            } else {
                if (list->overall > temp->overall) {
                    temp = list;
                }
            }
            /* jump to next entry in list */
            list = next_ctcp();
        }

        /* at the end of this loop temp should point to the highest value in list, that is smaller 
           than all other values already found */

        if (temp->version) {
            if (!sortedlist) {
                /* make first entry in sorted list */
                sortedlist = temp;
                sortedlist->prevsort = NULL;
                sortedlist->nextsort = NULL;
                /* we will return this */
                firstsortedlist = sortedlist;
            } else {
                /* If we got the dummy, let's get out of here */
                if (!stricmp(temp->version, ""))
                    break;
                /* make a new entry in sorted list */
                sortedlist->nextsort = temp;
                temp->prevsort = sortedlist;
                temp->nextsort = NULL;
                sortedlist = temp;
            }
        }
    }

    /* free dummy */
    denora_free(dummy->version);
    denora_free(dummy);

    return firstsortedlist;
}

/*************************************************************************/

int find_in_sortedlist(TLD * sortedlist, char *string)
{
    while (sortedlist) {
        if (stricmp(sortedlist->country, string) == 0) {
            return 1;
        }
        sortedlist = sortedlist->nextsort;
    }
    return 0;
}

/*************************************************************************/

int find_in_sc_sortedlist(StatsChannel * sortedlist, char *string)
{
    while (sortedlist) {
        if (stricmp(sortedlist->name, string) == 0) {
            return 1;
        }
        sortedlist = sortedlist->nextsort;
    }
    return 0;
}

/*************************************************************************/

int find_in_ctcp_sortedlist(CTCPVerStats * sortedlist, char *string)
{
    while (sortedlist) {
        if (!BadPtr(string)) {
            if (stricmp(sortedlist->version, string) == 0) {
                return 1;
            }
        }
        sortedlist = sortedlist->nextsort;
    }
    return 0;
}

/*************************************************************************/
